#######################################################################
#  Indiana University Opie Lab Software License, Version 1.2
#
#  Copyright (C) 2002 The Trustees of Indiana University.
#  All rights reserved.
#
#  Redistribution and use in source and binary forms, with or without
#  modification, are permitted provided that the following conditions are
#  met:
#
#  1) All redistributions of source code must retain the above
#     copyright notice, the list of authors in the original source
#     code, this list of conditions and the disclaimer listed in this
#     license;
#
#  2) All redistributions in binary form must reproduce the above
#     copyright notice, this list of conditions and the disclaimer
#     listed in this license in the documentation and/or other
#     materials provided with the distribution;
#
#  3) Any documentation included with all redistributions must include
#     the following acknowledgement:
#
#       "This product includes software developed by the Indiana
#       University Opie Lab.  For further information please visit
#       http://www.cs.indiana.edu/~dswise"
#
#     Alternatively, this acknowledgment may appear in the software
#     itself, and wherever such third-party acknowledgments normally
#     appear.
#
#  4) The name "Indiana University" or "Indiana University
#     Opie Lab" shall not be used to endorse or promote
#     products derived from this software without prior written
#     permission from Indiana University.  For written permission,
#     please contact http://www.cs.indiana.edu/~dswise.
#
#  5) Products derived from this software may not use "Indiana
#     University" name nor may "Indiana University" appear in their name,
#     without prior written permission of the Indiana University.
#
#  Indiana University provides no reassurances that the source code
#  provided does not infringe the patent or any other intellectual
#  property rights of any other entity.  Indiana University disclaims any
#  liability to any recipient for claims brought by any other entity
#  based on infringement of intellectual property rights or otherwise.
#
#  LICENSEE UNDERSTANDS THAT SOFTWARE IS PROVIDED "AS IS" FOR WHICH
#  NO WARRANTIES AS TO CAPABILITIES OR ACCURACY ARE MADE. INDIANA
#  UNIVERSITY GIVES NO WARRANTIES AND MAKES NO REPRESENTATION THAT
#  SOFTWARE IS FREE OF INFRINGEMENT OF THIRD PARTY PATENT, COPYRIGHT, OR
#  OTHER PROPRIETARY RIGHTS.  INDIANA UNIVERSITY MAKES NO WARRANTIES THAT
#  SOFTWARE IS FREE FROM "BUGS", "VIRUSES", "TROJAN HORSES", "TRAP
#  DOORS", "WORMS", OR OTHER HARMFUL CODE.  LICENSEE ASSUMES THE ENTIRE
#  RISK AS TO THE PERFORMANCE OF SOFTWARE AND/OR ASSOCIATED MATERIALS,
#  AND TO THE PERFORMANCE AND VALIDITY OF INFORMATION GENERATED USING
#  SOFTWARE.
###################################################################

$inside_parse = 0;
$append_typeref = "";
$prepend_typeref = "";

while(<ARGV>) {
    if($_ =~ /(.*)declared_type(.*)/) { }
    elsif($_ =~ /(.*)top_level_file(.*)/) { }
    elsif($_ =~ /(.*)fp_contract(.*)/) { }
    elsif($_ =~ /(.*)fenv_access(.*)/) { }
    elsif($_ =~ /(.*)cx_limited_range(.*)/) { }
    elsif($_ =~ /(.*)vla_dimensions(.*)/) { }
    elsif($_ =~ /(.*)is_inline(.*)/) { }
    elsif($_ =~ /(.*)gcc_mode(.*)/) { }
    elsif($_ =~ /(.*)gpp_mode(.*)/) { }
    elsif($_ =~ /(.*)short_enums(.*)/) { }
    elsif($_ =~ /(.*)fmt_arg(.*)/) { }
    elsif($_ =~ /(.*)asm_name_is_valid(.*)/) { }
    elsif($_ =~ s/tk_typeref/tk_integer/) {$inside_parse=1; printf $_; } 
    elsif($inside_parse==1) 
    {
        if($_ =~ s/(.*)typeref_type:(.*)://) {#get the type
		if($_ =~ s/\n//g){$append_typeref = $_; }#take the newline out of the qualifiers
	}
	
	elsif($_ =~ s/(.*)qualifiers://) {#get the qualifiers
		if($_ =~ s/\n//){$prepend_typeref = $_; }#take the newline out of the qualifiers
	}

	elsif(!($prepend_typeref =~ /restrict/)){printf "int_kind:  " . $prepend_typeref . $append_typeref . "\n\n";$inside_parse=0;}#print the qualifiers and type as the int_kind
	else{printf "int_kind:  " . $append_typeref . $prepend_typeref . "\n\n";$inside_parse=0;}#print the qualifiers and type as the int_kind
    
    
    
    }
    else {
	printf $_;
    }
}
